package com.burtbeckwith.mdctest;

import java.io.IOException;
import java.security.Principal;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.MDC;

public class MdcFilter implements Filter {

	public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain)
			throws IOException, ServletException {
		try {
			Principal principal = ((HttpServletRequest)req).getUserPrincipal();
			MDC.put("username", principal == null ? "N/A" : principal.getName());
			chain.doFilter(req, res);
		}
		finally {
			MDC.remove("username");
		}
	}

	public void init(FilterConfig fc) {/*nothing to do*/}
	public void destroy() {/*nothing to do*/}
}

